//klasa kopca

template<class T>
class _lt_pred
{
public:
	bool operator()(T a,T b) {return a<b;}
};

template<class T,class P=_lt_pred<T> >
class Heap
{
private:
	T *v;
	int n,s;
	P pred;

	void upheap(int p)
	{
		T temp=v[p];
		while (p>1 && pred(temp,v[p/2]))
		{
			v[p]=v[p/2];
			p/=2;
		}
		v[p]=temp;
	}

	void downheap(int p)
	{
		T temp=v[p];
		while (2*p<=n)
		{
			int e=2*p;
			if (e+1<=n)
			{
				if (pred(v[e+1],v[e])) e++;
			}
			if (pred(temp,v[e])) break;
			v[p]=v[e];
			p=e;
		}
		v[p]=temp;
	}

public:
	Heap(int _s,P _p=_lt_pred<T>())
	{
		s=_s;
		v=new T[s+1];
		n=0;
		pred=_p;
	}
	
	Heap(T *tab,int _s,P _p=_lt_pred<T>())
	{
		s=_s;
		v=new T[s+1];
		for (int i=1; i<=s; i++) v[i]=tab[i-1];
		n=s;
		pred=_p;
		for (int i=n/2; i>0; i--) downheap(i);
	}

	void Insert(T e)
	{
		v[++n]=e;
		upheap(n);
	}

	T &GetMax() {return v[1];}
	T DeleteMax()
	{
		T temp=v[1];
		v[1]=v[n--];
		downheap(1);
		return temp;
	}

	int Size() {return n;}

};

template<class T>
void HeapSort(T *A,int n)
{
	Heap<T> h(A,n);
	for (int i=0; i<n; i++) A[i]=h.DeleteMax();
}
