//bity od i do i+j-1
template<class T,int nbits>
inline int Bits(T v,int i)
{
	return (v>>i)&(~((~0)<<nbits));
}

//optymalne nbits=8
template<class T,int nbits>
void RadixSort(T *_A,int n)
{
	const int Tbits=sizeof(T)*8;
	const int csize=1<<nbits;
	T *_B=new T[n];
	T *A=_A,*B=_B;

	for (int pos=0; pos<Tbits; pos+=nbits)
	{
		int c[csize];

		memset(c,0,sizeof(c));
			
		for (int i=0; i<n; i++)
			c[Bits<T,nbits>(A[i],pos)]++;
			
		for (int i=1; i<csize; i++)
			c[i]+=c[i-1];

		for (int i=n-1; i>=0; i--)
			B[--c[Bits<T,nbits>(A[i],pos)]]=A[i];

		T *tmp=A; A=B; B=tmp;
	}
	if (A!=_A) memcpy(_A,_B,n*sizeof(T));
	delete []B;
}
