#include <iostream>
#include <algorithm>
#include <time.h>

using namespace std;

#define SHOW(A,N) for (int i=0; i<N; i++) cout << A[i] << ", "

#include "insert_sort.h"
#include "radix_sort.h"
#include "xchradix_sort.h"
#include "heap_sort.h"
#include "merge_sort.h"
#include "qsort.h"

#include "t.h"

int main(int argc,char *argv[])
{
	int N;
	if (argc<2) N=1000;
	else N=atol(argv[1]);
	
	int *A=new int[N];
	int *_A=new int[N];

	srand(time(0));
	for (int i=0; i<N; i++) _A[i]=rand();
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	QSort(A,N);
	stop("QSort:\t\t\t");
	check(A,N);
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	QSort(A,N,1);
	stop("QSort (1rek):\t\t");
	check(A,N);
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	QSort(A,N,2);
	stop("QSort (+inssort):\t");
	check(A,N);
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	RadixSort<int,1>(A,N);
	stop("RadixSort 1:\t\t");
	check(A,N);
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	RadixSort<int,4>(A,N);
	stop("RadixSort 4:\t\t");
	check(A,N);
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	RadixSort<int,8>(A,N);
	stop("RadixSort 8:\t\t");
	check(A,N);
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	RadixSort<int,10>(A,N);
	stop("RadixSort 10:\t\t");
	check(A,N);
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	XChangeRadixSort(A,N);
	stop("XChRadixSort:\t\t");
	check(A,N);
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	HeapSort(A,N);
	stop("Heap sort:\t\t");
	check(A,N);;
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	MergeSort(A,N);
	stop("Merge sort:\t\t");
	check(A,N);;
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	sort(&A[0],&A[N]);
	stop("STL sort:\t\t");
	check(A,N);
	
	memcpy(A,_A,sizeof(int)*N);
	start;
	InsertionSort(A,N);
	stop("InsertionSort:\t\t");
	check(A,N);

	return 0;
}
